/*!
 * The MIT License (MIT)
 * 
 * Copyright (c) 2019 Tarek Sherif
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy of
 * this software and associated documentation files (the "Software"), to deal in
 * the Software without restriction, including without limitation the rights to
 * use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
 * the Software, and to permit persons to whom the Software is furnished to do so,
 * subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
 * COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
 * IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 * 
 */
!function(n,e){"object"==typeof exports&&"object"==typeof module?module.exports=e():"function"==typeof define&&define.amd?define([],e):"object"==typeof exports?exports.MercatorGL=e():n.MercatorGL=e()}(window,(function(){return function(n){var e={};function t(r){if(e[r])return e[r].exports;var o=e[r]={i:r,l:!1,exports:{}};return n[r].call(o.exports,o,o.exports,t),o.l=!0,o.exports}return t.m=n,t.c=e,t.d=function(n,e,r){t.o(n,e)||Object.defineProperty(n,e,{enumerable:!0,get:r})},t.r=function(n){"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(n,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(n,"__esModule",{value:!0})},t.t=function(n,e){if(1&e&&(n=t(n)),8&e)return n;if(4&e&&"object"==typeof n&&n&&n.__esModule)return n;var r=Object.create(null);if(t.r(r),Object.defineProperty(r,"default",{enumerable:!0,value:n}),2&e&&"string"!=typeof n)for(var o in n)t.d(r,o,function(e){return n[e]}.bind(null,o));return r},t.n=function(n){var e=n&&n.__esModule?function(){return n.default}:function(){return n};return t.d(e,"a",e),e},t.o=function(n,e){return Object.prototype.hasOwnProperty.call(n,e)},t.p="",t(t.s=0)}([function(n,e,t){"use strict";t.r(e),t.d(e,"highPrecisionLngLat",(function(){return i})),t.d(e,"injectMercatorGLSL",(function(){return _})),t.d(e,"allocateMercatorUniforms",(function(){return g})),t.d(e,"updateMercatorUniforms",(function(){return u})),t.d(e,"pixelsPerMeter",(function(){return L})),t.d(e,"pixelsPerDegree",(function(){return f})),t.d(e,"lngLatToWorld",(function(){return v})),t.d(e,"worldToClip",(function(){return m})),t.d(e,"lngLatToClip",(function(){return s}));const r=Math.PI,o=r/4,a=r/180;let l=new Float64Array(4),c=new Float32Array(2);function i(n,e=0,t=2){let r=Math.ceil((n.length-e)/t),o=new Float32Array(2*r);for(let a=0;a<r;++a){let r=e+a*t,l=2*a;o[l]=n[r]-Math.fround(n[r]),o[l+1]=n[r+1]-Math.fround(n[r+1])}return o}function _(n){let e=n.match(/#version \d+(\s+es)?\s*\n/),t=e?e[0]:"";return n.replace(t,t+"\n#define MERCATOR_GL_TILE_SIZE 512.0\n#define MERCATOR_GL_PI 3.1415926536\n#define MERCATOR_GL_WORLD_SCALE (MERCATOR_GL_TILE_SIZE / (MERCATOR_GL_PI * 2.0))\n#define MERCATOR_GL_OFFSET_THRESHOLD 4096.0\n\nuniform vec2 mercator_gl_lngLatCenter;\nuniform vec3 mercator_gl_angleDerivatives;\nuniform float mercator_gl_scale;\nuniform vec4 mercator_gl_clipCenter;\nuniform mat4 mercator_gl_viewProjectionMatrix;\n\nvec4 mercator_gl_lngLatToWorld(vec3 lngLatElevation, vec2 lngLatPrecision) {\n    vec3 mercatorPosition;\n    if (mercator_gl_scale < MERCATOR_GL_OFFSET_THRESHOLD) {\n        mercatorPosition.xy = vec2(\n            (radians(lngLatElevation.x) + MERCATOR_GL_PI) * MERCATOR_GL_WORLD_SCALE,\n            (MERCATOR_GL_PI - log(tan(MERCATOR_GL_PI * 0.25 + radians(lngLatElevation.y) * 0.5))) * MERCATOR_GL_WORLD_SCALE\n        ) * mercator_gl_scale;\n        mercatorPosition.z = lngLatElevation.z;\n    } else {\n        mercatorPosition.xy = (lngLatElevation.xy - mercator_gl_lngLatCenter) + lngLatPrecision;\n        float dy = mercatorPosition.y;\n        mercatorPosition = vec3(\n            mercatorPosition.x * mercator_gl_angleDerivatives.x,\n            -mercatorPosition.y * (mercator_gl_angleDerivatives.y - dy * mercator_gl_angleDerivatives.z),\n            lngLatElevation.z\n        );\n    }\n\n    return vec4(mercatorPosition, 1.0);\n}\n\nvec4 mercator_gl_lngLatToWorld(vec3 lngLatElevation) {\n    return mercator_gl_lngLatToWorld(lngLatElevation, vec2(0.0));\n}\n\nvec4 mercator_gl_lngLatToWorld(vec2 lngLat, vec2 lngLatPrecision) {\n    return mercator_gl_lngLatToWorld(vec3(lngLat, 0.0), lngLatPrecision);\n}\n\nvec4 mercator_gl_lngLatToWorld(vec2 lngLat) {\n    return mercator_gl_lngLatToWorld(vec3(lngLat, 0.0));\n}\n\nvec4 mercator_gl_worldToClip(vec4 worldPosition) {\n    if (mercator_gl_scale >= MERCATOR_GL_OFFSET_THRESHOLD) {\n        worldPosition.w = 0.0;\n    }\n    vec4 clipPosition = mercator_gl_viewProjectionMatrix * worldPosition;\n    if (mercator_gl_scale >= MERCATOR_GL_OFFSET_THRESHOLD) {\n        clipPosition += mercator_gl_clipCenter;\n    }\n\n    return clipPosition;\n}\n\nvec4 mercator_gl_lngLatToClip(vec3 lngLatElevation, vec2 lngLatPrecision) {\n    return mercator_gl_worldToClip(mercator_gl_lngLatToWorld(lngLatElevation, lngLatPrecision));\n}\n\nvec4 mercator_gl_lngLatToClip(vec3 lngLatElevation) {\n    return mercator_gl_lngLatToClip(lngLatElevation, vec2(0.0));\n}\n\nvec4 mercator_gl_lngLatToClip(vec2 lngLat, vec2 lngLatPrecision) {\n    return mercator_gl_lngLatToClip(vec3(lngLat, 0.0), lngLatPrecision);\n}\n\nvec4 mercator_gl_lngLatToClip(vec2 lngLat) {\n    return mercator_gl_lngLatToClip(vec3(lngLat, 0.0));\n}\n\n")}function g(n={}){return n.mercator_gl_lngLatCenter=new Float32Array(2),n.mercator_gl_angleDerivatives=new Float32Array(3),n.mercator_gl_clipCenter=new Float32Array(4),n.mercator_gl_viewProjectionMatrix=new Float32Array(16),n.mercator_gl_scale=0,n}function u(n,e,t,r){let o=e[0],l=e[1];n.mercator_gl_scale=Math.pow(2,t),n.mercator_gl_lngLatCenter[0]=o,n.mercator_gl_lngLatCenter[1]=l;let i=Math.cos(l*a),_=a*Math.tan(l*a)/i;return function(n,e,t,r,o){f(n,e,t,r),n[2]=n[0]*o/2}(n.mercator_gl_angleDerivatives,l,t,i,_),c[0]=o,c[1]=l,s(n.mercator_gl_clipCenter,c,t,r),n.mercator_gl_viewProjectionMatrix.set(r),n}function L(n,e,t=Math.cos(n*a)){return 512*Math.pow(2,e)/4003e4/t}function f(n,e,t,r=Math.cos(e*a)){let o=Math.pow(2,t);return n[0]=512*o/360,n[1]=n[0]/r,n}function v(n,e,t){let l=e[0],c=e[1],i=Math.pow(2,t),_=c*a,g=512*i*(l*a+r)/(2*r),u=512*i*(r-Math.log(Math.tan(o+.5*_)))/(2*r);return n[0]=g,n[1]=u,n[2]=0,n[3]=1,n}function m(n,e,t){return function(n,e,t){let r=e[0],o=e[1],a=e[2],l=e[3];n[0]=t[0]*r+t[4]*o+t[8]*a+t[12]*l,n[1]=t[1]*r+t[5]*o+t[9]*a+t[13]*l,n[2]=t[2]*r+t[6]*o+t[10]*a+t[14]*l,n[3]=t[3]*r+t[7]*o+t[11]*a+t[15]*l}(n,e,t),n}function s(n,e,t,r){return v(l,e,t),m(n,l,r),n}}])}));
//# sourceMappingURL=mercator-gl.min.js.map